import { BrowserContext, ElectronApplication, Page, _electron as electron } from 'playwright';
import { test, expect } from '@playwright/test';
import * as PATH from 'path';
import {GameModel} from "../../../src/app/game-model/GameModel";
import {Gamesystem} from "../../src/app/game-model/gamesystems/Gamesystem";
import {ScriptAccount} from "../../../src/app/game-model/scriptAccounts/ScriptAccount";
import {ModelComponentType} from "../../../src/app/game-model/ModelComponentType";
import {SimpleGamesystem} from "../../../src/app/game-model/gamesystems/SimpleGamesystem";
import exp = require("node:constants");
import {end} from "electron-debug";
import {GamesystemTrainer} from "./GamesystemTrainer";
import {ProductGamesystem} from "../../../src/app/game-model/gamesystems/ProductGamesystem";
import {ProductStateTrainer} from "./ProductStateTrainer";
import {SimpleState} from "../../../../src/app/game-model/gamesystems/states/SimpleState";
import {ProductSystemGenerationTrainer} from "./ProductSystemGenerationTrainer";
test.describe('Test Create ProductStates', () => {

  test("Test simple Binary Product State", async () => {
    const gamesystem = ProductSystemGenerationTrainer.givenSimplestProductSystem();
    gamesystem.generateFromChildsystems();

    expect(gamesystem.states.length).toEqual(4);
    expect(gamesystem.transitions.length).toEqual(5);
  })

  test("Test simple triple Product State", async () => {
    const gamesystem = ProductSystemGenerationTrainer.givenTrippleProductSystem();
    gamesystem.generateFromChildsystems();

    expect(gamesystem.states.length).toEqual(8);
    expect(gamesystem.transitions.length).toEqual(19)
  })

});
